import { ReactNode } from 'react';
import { CombinedError } from 'urql';
import { HandleCombinedErrorContext } from './MqlContext';
export interface AcceptedHeaders {
    'model-id'?: string;
}
declare type Props = {
    isAuthenticated: boolean;
    captureException?: (e: CombinedError, context: HandleCombinedErrorContext) => void;
    children: ReactNode;
    clientVersion: string;
    coreApiUrl?: string;
    externalConfig?: {
        mqlServerUrl?: string;
        refetchMqlServerUrl?: () => void;
        headers?: AcceptedHeaders;
    };
    mqlServerUrlOverride?: string;
    token?: string;
    serviceUserApiKey?: string;
};
declare function MqlContextProvider({ token, children, isAuthenticated, captureException, clientVersion, coreApiUrl, externalConfig, mqlServerUrlOverride, serviceUserApiKey, }: Props): JSX.Element;
export default MqlContextProvider;
