import { CreateMqlQueryMutationVariables } from '../../mutations/mql/MqlMutationTypes';
import { FetchMqlTimeSeriesQuery } from '../../queries/mql/MqlQueryTypes';
import { UseMqlQueryState } from '../reducers/mqlQueryReducer';
interface CommonMqlQueryParams {
    queryInput?: Omit<CreateMqlQueryMutationVariables, 'attemptNum'>;
    skip?: boolean;
    retries?: number;
    refetchMqlQueryAttempt?: number;
}
interface SingleMetricMqlQueryParams extends CommonMqlQueryParams {
    metricName: string;
    metricNames?: never;
}
interface MultipleMetricsMqlQueryParams extends CommonMqlQueryParams {
    metricName?: never;
    metricNames: string[];
}
declare type UseMqlQueryParams = SingleMetricMqlQueryParams | MultipleMetricsMqlQueryParams;
export declare type UseTimeSeriesMqlQuery = UseMqlQueryState<FetchMqlTimeSeriesQuery>;
export default function useTimeSeriesMqlQuery({ queryInput, metricName, metricNames, skip, retries, refetchMqlQueryAttempt, }: UseMqlQueryParams): UseMqlQueryState<FetchMqlTimeSeriesQuery>;
export {};
