"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useCreateTimeSeriesMqlQuery_1 = __importDefault(require("./utils/useCreateTimeSeriesMqlQuery"));
// import { CombinedError } from "urql";
var MqlContext_1 = __importDefault(require("../../context/MqlContext/MqlContext"));
var FetchMqlQueryTimeSeries_1 = __importDefault(require("../../queries/mql/FetchMqlQueryTimeSeries"));
var mqlQueryReducer_1 = __importStar(require("../reducers/mqlQueryReducer"));
var useFetchMqlQuery_1 = __importDefault(require("../utils/useFetchMqlQuery"));
// This custom hook consists of two useHooks that should asynchronously handle all scenarios for this chained
// data fetching we are doing. It should do it in a high performance way and in a way that is resilient to race conditions if the
// user updates their request while a query is in flight
function useTimeSeriesMqlQuery(_a) {
    var queryInput = _a.queryInput, metricName = _a.metricName, metricNames = _a.metricNames, skip = _a.skip, _b = _a.retries, retries = _b === void 0 ? 5 : _b, refetchMqlQueryAttempt = _a.refetchMqlQueryAttempt;
    var mqlServerUrl = react_1.useContext(MqlContext_1.default).mqlServerUrl;
    var dataAccr = function (data) { var _a; return (_a = data === null || data === void 0 ? void 0 : data.createMqlQuery) === null || _a === void 0 ? void 0 : _a.query; };
    var reducer = mqlQueryReducer_1.default(dataAccr);
    var _c = react_1.useReducer(reducer, mqlQueryReducer_1.initialState), state = _c[0], dispatch = _c[1];
    var useCreateTimeSeriesMqlQueryArgs = react_1.useMemo(function () { return (__assign(__assign({}, (metricName
        ? {
            metricName: metricName,
        }
        : {
            metricNames: metricNames,
        })), { formState: queryInput, dispatch: dispatch,
        retries: retries,
        refetchMqlQueryAttempt: refetchMqlQueryAttempt })); }, [
        metricName,
        metricNames,
        queryInput,
        dispatch,
        retries,
        refetchMqlQueryAttempt,
    ]);
    var createTimeSeriesMqlQuery = useCreateTimeSeriesMqlQuery_1.default(useCreateTimeSeriesMqlQueryArgs).createTimeSeriesMqlQuery;
    react_1.useEffect(function () {
        if ((!metricName && !metricNames) || !mqlServerUrl || skip) {
            return;
        }
        dispatch({
            type: 'postQueryStart',
            doRefetchMqlQuery: Boolean(refetchMqlQueryAttempt),
        });
        createTimeSeriesMqlQuery({ stateRetries: state.retries });
    }, [
        queryInput,
        metricName,
        metricNames,
        mqlServerUrl,
        skip,
        refetchMqlQueryAttempt,
    ]);
    var _skip = skip ||
        !state.queryId ||
        state.cancelledQueries.includes(state.queryId); /* && !isRunning*/
    useFetchMqlQuery_1.default({
        state: state,
        skip: _skip,
        dispatch: dispatch,
        createQueryIdQuery: createTimeSeriesMqlQuery,
        retries: retries,
        fetchDataQuery: FetchMqlQueryTimeSeries_1.default,
        refetchMqlQueryAttempt: refetchMqlQueryAttempt,
    });
    return state;
}
exports.default = useTimeSeriesMqlQuery;
