import { Dispatch } from 'react';
import { CreateMqlQueryMutation, CreateMqlQueryMutationVariables } from '../../../mutations/mql/MqlMutationTypes';
import { FetchMqlTimeSeriesQuery } from '../../../queries/mql/MqlQueryTypes';
import { Action as UseMqlQueryAction } from '../../reducers/mqlQueryReducer';
export interface DoCreateMqlQueryArgs {
    stateRetries: number;
}
interface CommonUseCreateMqlQueryArgs {
    retries: number;
    formState?: Omit<CreateMqlQueryMutationVariables, 'attemptNum'>;
    dispatch: Dispatch<UseMqlQueryAction<CreateMqlQueryMutation, FetchMqlTimeSeriesQuery>>;
    refetchMqlQueryAttempt?: number;
}
export interface SingleMetricUserCreateMqlQueryArgs extends CommonUseCreateMqlQueryArgs {
    metricName: string;
    metricNames?: never;
}
export interface MultipleMetricsUserCreateMqlQueryArgs extends CommonUseCreateMqlQueryArgs {
    metricName?: never;
    metricNames: string[];
}
declare type UseCreateMqlQueryArgs = SingleMetricUserCreateMqlQueryArgs | MultipleMetricsUserCreateMqlQueryArgs;
interface UseCreateMqlQuery {
    createTimeSeriesMqlQuery: (args: DoCreateMqlQueryArgs) => void;
}
declare const useCreateTimeSeriesMqlQuery: ({ metricName, metricNames, formState, dispatch, retries, refetchMqlQueryAttempt, }: UseCreateMqlQueryArgs) => UseCreateMqlQuery;
export default useCreateTimeSeriesMqlQuery;
