"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var urql_1 = require("urql");
var buildAuthExchange_1 = __importDefault(require("./buildAuthExchange"));
function cleanUrl(url) {
    if (url.endsWith("/graphql"))
        return url;
    if (url.endsWith("/"))
        return url + "graphql";
    return url + "/graphql";
}
function buildMqlUrqlClient(_a) {
    var clientVersion = _a.clientVersion, mqlUrl = _a.mqlUrl, token = _a.token, headers = _a.headers;
    return urql_1.createClient({
        url: cleanUrl(mqlUrl),
        fetchOptions: {
            headers: __assign({}, headers),
        },
        exchanges: [urql_1.dedupExchange, buildAuthExchange_1.default(clientVersion, token), urql_1.fetchExchange],
    });
}
exports.default = buildMqlUrqlClient;
